// Uses Twilio.Data.Module for the rest api calls. Simply for testing querys.
// Visual aspect is for testing purposes only and has no affect on the client.
// Authors:
// Cameron Hayes
// Elias Serraf
// Mac ...
unit Data;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvUtil, Data.DB, Vcl.Grids, AdvObj,
  BaseGrid, AdvGrid, DBAdvGrid, MemDS, DBAccess, Uni, Vcl.StdCtrls, Vcl.Mask,
  vcl.wwdbedit, vcl.wwdotdot, vcl.wwdbcomb, REST.Client, REST.Types, System.JSON,
  System.Generics.Collections, AdvEdit, vcl.wwdblook, vcl.wwdbdatetimepicker,
  System.Hash;

type
  TFData = class(TForm)
    dsUsers: TDataSource;
    btnFind: TButton;
    Memo1: TMemo;
    DBAdvGrid1: TDBAdvGrid;
    DBAdvGrid2: TDBAdvGrid;
    dsRecordings: TDataSource;
    edtUsername: TEdit;
    edtPassword: TEdit;
    lblHash: TLabel;
    btnAddUser: TButton;
    lblHash2: TLabel;
    uqUsers: TUniQuery;
    cbAdmin: TCheckBox;
    edtFullName: TEdit;
    edtPhoneNumber: TEdit;
    edtEmailAddress: TEdit;
    btnPDF: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnFindClick(Sender: TObject);
    procedure btnPDFClick(Sender: TObject);
  private
    accountSID: string;
    authHeader: string;
  public
    function GetReportPDF(OrderID: string): string;
  end;

var
  FData: TFData;

implementation

{$R *.dfm}

uses KGOrders.Database, uLibrary, rOrders;

procedure TFData.btnPDFClick(Sender: TObject);
begin
  GetReportPDF('');
end;


procedure TFData.FormCreate(Sender: TObject);
begin
  KGOrdersDatabase := TKGOrdersDatabase.Create(Self);
end;

procedure TFData.btnFindClick(Sender: TObject);
// Retrieves calls from a specific number from the database.
// SQL: SQL statement to retrieve calls from the database
// whereSQL: where section of the SQL that is built in the function
var
  SQL: string;
  whereSQL: string;
begin
  Memo1.Lines.Add(uqUsers.Connection.Server);
  SQL := 'select * from users';
  uqUsers.Close;
  uqUsers.SQL.Text := sql;
  uqUsers.Open;

  DBAdvGrid1.AutoSizeColumns(true);
end;


function TFData.GetReportPDF(OrderID: string): string;
var
  rptOrders: TrptOrders;  // Local instance
  OrderIDList: TStringList;
begin
  rptOrders := TrptOrders.Create(nil);  // Always create locally
  try
    // Create a list of hardcoded OrderIDs for testing
    OrderIDList := TStringList.Create;
    try
      OrderIDList.Add('18995');
      OrderIDList.Add('18994');
      OrderIDList.Add('18993');  // Add more OrderIDs as needed

      // Generate the PDF Report with the list of OrderIDs
//      rptOrders.GenerateSimpleReport(350);
    finally
      OrderIDList.Free;  // Free the TStringList
    end;
  finally
    rptOrders.Free;  // Ensure rptOrders is freed
  end;
end;



end.
