unit rOrders;

interface

uses
  System.SysUtils, System.Classes, frxClass, frxExportBaseDialog, frxExportPDF,
  Data.DB, DBAccess, Uni, UniProvider, MySQLUniProvider, System.IniFiles, Vcl.Forms,
  MemDS, frxDBSet, System.IOUtils, Common.Logging, frxTableObject, frCoreClasses;

type
  TrptOrders = class(TDataModule)
    frxOrders: TfrxReport;
    frxPDFExport1: TfrxPDFExport;
    ucKG: TUniConnection;
    frxDBOrders: TfrxDBDataset;
    uqOrders: TUniQuery;
    uqOrdersORDER_ID: TIntegerField;
    uqOrdersLOCATION: TStringField;
    uqOrdersCOMPANY_NAME: TStringField;
    uqOrdersJOB_NAME: TStringField;
    uqOrdersORDER_DATE: TDateField;
    uqOrdersORDER_TYPE: TStringField;
    uqOrdersPROOF_DUE: TDateField;
    uqOrdersPROOF_DONE: TDateTimeField;
    uqOrdersART_DUE: TDateField;
    uqOrdersART_DONE: TDateTimeField;
    uqOrdersPLATE_DUE: TDateField;
    uqOrdersPLATE_DONE: TDateTimeField;
    uqOrdersMOUNT_DUE: TDateField;
    uqOrdersMOUNT_DONE: TDateTimeField;
    uqOrdersSHIP_DUE: TDateField;
    uqOrdersSHIP_DONE: TDateTimeField;
    uqOrdersPRICE: TFloatField;
    uqOrdersQB_REF_NUM: TStringField;
    uqOrdersCOLORS: TStringField;
    procedure DataModuleCreate(Sender: TObject);
  public
    procedure PrepareReport(const SQL: string);
    procedure GeneratePDF;
  end;

var
  rptOrders: TrptOrders;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

procedure TrptOrders.DataModuleCreate(Sender: TObject);
var
  iniFile: TIniFile;
begin
  iniFile := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'kgOrdersServer.ini');
  try
    ucKG.Server := iniFile.ReadString('Database', 'Server', '');
    ucKG.Connect;
  finally
    iniFile.Free;
  end;
end;

procedure TrptOrders.PrepareReport(const SQL: string);
begin
  // Prepare and open the query
  uqOrders.Close;
  uqOrders.SQL.Text := SQL;
  uqOrders.Open;
end;

procedure TrptOrders.GeneratePDF;
var
  ReportFileName: string;
begin
  ReportFileName := TPath.Combine('C:\Projects\KGOrders\Reports',
                    'OrderReport_' + FormatDateTime('yyyymmdd_hhnnss', Now) + '.pdf');

  if not DirectoryExists(ExtractFilePath(ReportFileName)) then
    ForceDirectories(ExtractFilePath(ReportFileName));

  // Generate the report
  frxOrders.PrepareReport;
  frxPDFExport1.FileName := ReportFileName;
  frxPDFExport1.ShowDialog := False;
  frxOrders.Export(frxPDFExport1);
  Logger.log(5, 'PDF saved to: ' + ReportFileName);
end;

end.

end.
